
#include <iostream>
#include <queue>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <vector>
#include <cstdlib>
#include <ctime>
using namespace std;

int solve() {
    int m, n, a, k;
    double left = 0, right = 0;
    scanf("%d %d %d %d", &m, &n, &a, &k);
    double h = (0.0 + n) / 2.0;
    for (int i = 0; i < k; ++i) {
        int t, x, y;
        scanf("%d %d %d", &t, &x, &y);
        if (t == 0) {
            if (x + a <= h) left += a * a;
            else if (x >= h) right += a * a;
            else left += (h - x) * a, right += (a - (h - x)) * a;
        } else if (t == 1 || t == 2) {
            if (x + a <= h) left += (a * a + 0.0) / 2;
            else if (x >= h) right += (a * a + 0.0) / 2;
            else {
                right += ((a - (h - x)) * (0.0 + a - (h - x))) / 2;
                left += (a * a + 0.0) / 2 - ((0.0 + a - (h - x)) * (a - (h - x))) / 2;
            }
        } else {
            x -= a;
            if (x + a <= h) left += (a * a + 0.0) / 2;
            else if (x >= h) right += (a * a + 0.0) / 2;
            else {
                left += (0.0 + h - x) * (h - x) / 2.0;
                right += (a * a + 0.0) / 2 -  (0.0 + h - x) * (h - x) / 2.0;
            }
        }
    }
    if (left - right > 1e-6)
        return 1;
    else if (right - left > 1e-6)
        return -1;
    return 0;
}

int main() {
    int P;
    cin >> P;
    
    for (int i = 0; i < P; ++i)
        cout << solve() << endl;
    return 0;
}
