#include <iostream>
#include <math.h>
#define eps 1e-9
using namespace std;

void solve()
{
    int N, M, K;
    double A;
    cin >> N >> M >> A >> K;
    double left = 0, right = 0;
    double mid = (double)M/2;
    for (int i = 0; i < K; i++)
    {
        double orr, x, y;
        cin >> orr >> x >> y;
        if (orr == 0)
        {
            if (x < mid) 
            {
                double r = min(mid, x + A);
                left += (r-x)*A;
            }
            if (x + A > mid)
            {
                double l = max(mid, x);
                right += (x + A - l)*A;
            }
        }
        if (orr == 1 || orr == 2)
        {
            if (x < mid)
            {
                double r = min(mid, x + A);
                left += A*A/2 - (x+A-r)*(x+A-r)/2;            
            }
            if (x + A > mid)
            {
                double l = max(mid, x); 
                right += (x + A - l)*(x + A - l)/2;
            }
        }
        else
        {
            if (x < mid)
            {
                double r = min(mid, x+A);
                left += (r - x)*(r-x)/2;
            }
            if (x + A > mid)
            {
                double l = max(x, mid);
                right += A*A/2 - (l - x)*(l-x)/2;
            }
        }
    }
    //cout << left << " " << right << endl;
    if (fabs(right-left) < eps) cout << 0 << endl;
    else if (right < left) cout << 1 << endl;
    else cout << -1 << endl;
    
}

int main()
{
    int T;
    cin >> T;
    for (int i = 0; i < T; i++) solve();
}
