
#include <iostream>
#include <queue>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <vector>
#include <cstdlib>
#include <ctime>
using namespace std;

inline int next() {
    int x;
    scanf("%d", &x);
    return x;
}

int solve() {
    int M = next() * 2;
    int N = next() * 2;
    long long A = next() * 2;
    int K = next();
    
    int H = N / 2;
    
    long long L = 0, R = 0;
    for (int i = 0; i < K; ++i) {
        int T = next();
        long long X = next() * 2;
        long long Y = next() * 2;
        if (T == 0) {
            if (X + A <= H) L -= A * A * 2;
            else if (X >= H) R -= A * A * 2;
            else L -= (H - X) * A * 2, R -= (A + X - H) * A * 2;
        } else if (T == 1 || T == 2) {
            if (X + A <= H) L -= A * A;
            else if (X >= H) R -= A * A;
            else {
                R -= (A + X - H) * (A + X - H);
                L -= A * A - (A + X - H) * (A + X - H);
            }
        } else if (T == 3 || T == 4) {
            X -= A;
            if (X + A <= H) L -= A * A;
            else if (X >= H) R -= A * A;
            else {
                L -= (H - X) * (H - X);
                R -= A * A - (H - X) * (H - X);
            }
        }
    }
    if (L > R) return -1;
    if (L == R) return 0;
    if (L < R) return 1;
}

int main() {
    int P = next();
    for (int i = 0; i < P; ++P)
        printf("%d\n", solve());
    return 0;
}
