
#include <iostream>
#include <queue>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <vector>
#include <cstdlib>
#include <ctime>
#include <stack>
using namespace std;

string solve() {
    string s;
    cin >> s;
    
    stack <char> stk;
    for (int i = 0; i < (int) s.size(); ++i)
        if (s[i] == '(' || s[i] == '[' || s[i] == '{')
            stk.push(s[i]);
        else {
            if (stk.empty())
                return "Berbat";
            char ch = stk.top(); stk.pop();
            switch (ch) {
                case ')': if (ch != '(') return "Berbat"; break;
                case ']': if (ch != '[') return "Berbat"; break;
                case '}': if (ch != '{') return "Berbat"; break;
            }
        }
    if (stk.empty())
        return "Guzel";
    return "Berbat";
}

int main() {
    int P;
    cin >> P;
    
    for (int i = 0; i < P; ++i)
        cout << solve() << endl;
    return 0;
}
