#include <cstdio>
#include <cstring>
#include <algorithm>

int l , r;
char a[1 << 20];
int used[1 << 13];

void read() {
    scanf ( "%d%d" , &l , &r );
    scanf ( "%s" , a );
}

void solve() {
    int i;
    int len;
    int ans , res;
    int mask;
    int n = (int)strlen ( a );
    
    ans = 0;
    
    for ( ; l <= r; l ++) {
        mask = 0;
        
        memset ( used , 0 , sizeof used );
        
        for (i = 0; i < n; i++) {
            mask &= ~(1 << (l - 1));
            mask = (mask << 1) | (a[i] - '0');
            
            if ( i >= l - 1 )
                used[mask] ++;
        }
        
        for (i = 0; i < (1 << 13); i++) {
            if ( used[i] > ans ) {
                ans = used[i];
                res = i;
                len = l;
            }
        }
    }
    
    for (i = len; i >= 1; i--)
        printf ( "%d" , !!(res & (1 << (i - 1))) );
    printf ( "\n" );
}

int main() {
    int cases;
    
    scanf ( "%d" , &cases );
    while ( cases -- ) {
        read();
        solve();
    }
    
    return 0;
}
