#include <cmath>
#include <cstdio>
#include <algorithm>

const double pi = 3.1415926535897932384626433832795;

struct point {
    double x , y;
    
    point() {}
    point ( double _x , double _y ) {
        x = _x; y = _y;
    }
};

point a[4] , b[4];

double dist ( point a , point b ) {
    return sqrt ( (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y) );
}

int main() {
    double n , v;
    double ans = 0.;
    int cases;
    int i;
    
    scanf ( "%d" , &cases );
    while ( cases -- ) {
        scanf ( "%lf%lf" , &n , &v );
        
        printf ( "%lf\n" , n );
        continue;
        
        a[0] = point ( 0 , 0 );
        a[1] = point ( n , 0 );
        a[2] = point ( n , n );
        a[3] = point ( 0 , n );
        
        ans = 0.;
        
        while ( fabs ( dist ( a[0] , a[1] ) ) > 1e-2 ) {
            ans += 1e-3;
            for (i = 0; i < 4; i++) {
                b[i].x = a[i].x + (a[(i + 1) % 4].x - a[i].x) * 1e-3 / dist ( a[i] , a[(i + 1) % 4] );
                b[i].y = a[i].y + (a[(i + 1) % 4].y - a[i].y) * 1e-3 / dist ( a[i] , a[(i + 1) % 4] );
            }
            
            for (i = 0; i < 4; i++)
                a[i] = b[i];
        }
    
        printf ( "%lf\n" , ans );
    }
    
    return 0;
}

