#include <iostream>
#include <cmath>
using namespace std;

#define eps 1e-6
struct point
{
	int x, y;
	int l;
	int c;
	void read(){ scanf("%d%d%d%d", &x, &y, &c, &l); }
};

point a[16];
point b[16];
point c[16]; int brc;
int n; int br;
int resm;int res;double ost = 0;

int dist(point p1, point p2)
{
	int aa = p1.x - p2.x;
	int bb = p1.y - p2.y;
	return aa*aa + bb*bb;
	
}
int DDD(point p0, point p1, point p2)
{
	return (p1.x - p0.x)*(p2.y - p0.y) - (p2.x - p0.x)*(p1.y - p0.y) ;
}

bool cmp(point p1, point p2)
{
	int pe = DDD(b[0], p1, p2);
	if(pe == 0) return dist (b[0], p1) < dist (b[0], p2);
return pe > 0;
}

void better(int mask, double PP, int cost, double len)
{
	if(len < PP + eps) return;
	
	if(cost < res){res = cost; resm = mask; ost = len - PP;}
	
	if(cost == res)
	{
		if(__builtin_popcount(mask) < __builtin_popcount(resm)) 
		{
			res = cost; resm = mask; ost = len - PP;
		}
	}
	
	
}

void update2(int mask)
{
	//cout<<mask<<endl;
	br = 0; int cost = 0;
	double len= 0.0;
int i;
	for(i = 0; i<n; i++)
	{
		if(mask&(1<<i)) {cost += a[i].c; len+=a[i].l;}
			else
			b[br++] = a[i];
	}
	
	if(br==0) {better(mask, 0.0, cost, len); return;}
	
	for(i = 1; i<br; i++) if(b[i].x < b[0].x || (b[i].x == b[0].x && b[i].y < b[0].y)) swap(b[0], b[i]);
		
	sort(b+1, b+br, cmp);
	b[br] = b[0]; 
	brc = 0;
	
	if(br==1) {better(mask, 0.0, cost, len); return;}
	if(br==2) {better(mask, 2.0*sqrt(dist(b[0], b[1])), cost, len); return;}
	
	c[brc++] = b[0];
	c[brc++] = b[1];
	
	for(i = 2;i<=br;i++)
	{
		while (brc>=2 && DDD(c[brc-2],c[brc-1],  b[i]) <=0 ) brc--;
		c[brc++] = b[i];
	}
	
	double PP = 0.0;
	for(i = 0;i< brc-1 ;i++)
	{
		PP += sqrt(dist(c[i], c[i+1]));
 	}
		
		better(mask, PP, cost, len);
	
}

void solve()
{
	scanf("%d", &n);
	res = 2000000000;
	resm = 1<<n;
	if(n==0){printf("0.00\n"); return;}
	int i;
	for(i = 0;i<n;i++)
		a[i].read();
	
	for(i = 1;i<(1<<n);i++)
		update2(i);

	for (i = 0;i<n;i++) 
		if(resm&(1<<i)) printf("%d ", i+1);
		printf("\n");
	printf("%.2lf\n", ost);

}

int main ()
{
	
	int pot;
	scanf("%d", &pot);
	while (pot--)
	solve();
	

}