#include <iostream>

using namespace std;

#define EPS 0.00001

typedef long double ld;

ld ldabs(ld a) {
	return a < 0 ? -a : a;
}

void solve() {
	ld m, n, a;
	int k;
	cin>>m>>n>>a>>k;
	ld center = 0;
	for(int i = 0; i < k; ++i) {
		ld x, y;
		int o;
		cin>>o>>x>>y;
		x -= n/2;
		if(o == 0) {
			x += a/2;
		} else if(o == 1 || o == 2) {
			x += a/3;
		} else if(o == 3 || o == 4) {
			x -= a/3;
		}
		if(ldabs(x) > EPS)
			center += (1+(o==0))/x;
	}
	if(center > -EPS && center < EPS) {
		cout<<"0"<<endl;
	} else if(center > 0) {
		cout<<"-1"<<endl;
	} else if(center < 0) {
		cout<<"1"<<endl;
	}
}

int main() {
	int n;
	cin>>n;
	for(int i = 0; i < n; ++i) solve();
}
