
#include <iostream>
#include <queue>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <vector>
#include <cstdlib>
#include <ctime>
#include <cassert>
using namespace std;

int solve() {
    int M, N, K;
    double A;
    scanf("%d %d %lf %d", &M, &N, &A, &K);
    
    double H = (N / 2.0);
    double L = H * M;
    double R = H * M;
    for (int i = 0; i < K; ++i) {
        int T;
        double X, Y;
        scanf("%d %lf %lf", &T, &X, &Y);
        if (T == 0) {
            if (X + A <= H) L -= A * A;
            else if (X >= H) R -= A * A;
            else L -= (H - X) * A, R -= (A - (H - X)) * A;
        } else if (T == 1 || T == 2) {
            if (X + A <= H) L -= (A * A) / 2.0;
            else if (X >= H) R -= (A * A) / 2.0;
            else {
                R -= ((X + A) - H) * ((X + A) - H) / 2.0;
                L -= (A * A) / 2.0 - ((X + A) - H) * ((X + A) - H) / 2.0;
            }
        } else if (T == 3 || T == 4) {
            X -= A;
            L -= (H - X) * (H - X) / 2.0;
            R -= (A * A) / 2.0 - (H - X) * (H - X) / 2.0;
        } else assert(false);
    }
    if (L + 1e-6 > R)
        return -1;
    else if (L < 1e-6 + R)
        return 1;
    else
        return 0;
}

int main() {
    int P;
    scanf("%d", &P);
    
    for (int i = 0; i < P; ++i) {
        printf("%d\n", solve());
    }
    return 0;
}
