#include <iostream>
#include <math.h>
#define eps 1e-9
#define PI 3.1415926535897932384626433832795
using namespace std;

double dist(double x1, double y1, double x2, double y2)
{
    return sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2));
}

int main()
{
    int qqqq;
    cin >> qqqq;
    
    for (int i = 0; i < qqqq; i++) 
    {
        double len, speed;
        cin >> len >> speed;
        double x1 = 0, y1 = 0, x2 = len, y2 = len;
        
        double d = len/100000;
        double ans = 0;
        while (1)
        {
           double ddd = dist(x1, y1, len/2, len/2);
           if (ddd < d) { d += ddd; break; }
           
           ans += d;
           double vx = x2 - x1, vy = y2 - y1;
           double reald = sqrt(vx*vx + vy*vy);
          
           x1 += vx*(d/reald);
           y1 += vy*(d/reald);
           x2 -= vx*(d/reald);
           y2 -= vy*(d/reald);
        }
        cout << (int)(ans + 0.5 + eps) << endl;
    }
    
    return 0;
}
