#include <iostream>
#include <stack>
#include <string>

using namespace std;

void solve() {
	string s;
	cin>>s;
	stack<char> st;
	for(int i = 0; i < s.size(); ++i) {
		char c = s[i];
		if(c == '(' || c == '[' || c == '{') {
			st.push(c);
		} else {
			if(c == ')') {
				if(st.empty()) {
					cout<<"Berbat"<<endl;
					return;
				}
				if(st.top() == '(') st.pop();
				else {
					cout<<"Berbat"<<endl;
					return;
				}
			}
			else if(c == ']') {
				if(st.empty()) {
					cout<<"Berbat"<<endl;
					return;
				}
				if(st.top() == '[') st.pop();
				else {
					cout<<"Berbat"<<endl;
					return;
				}
			}
			else if(c == '}') {
				if(st.empty()) {
					cout<<"Berbat"<<endl;
					return;
				}
				if(st.top() == '{') st.pop();
				else {
					cout<<"Berbat"<<endl;
					return;
				}
			}
		}
	}
	cout<<"Guzel"<<endl;
}

int main() {
	int n;
	cin>>n;
	for(int i = 0; i < n; ++i) solve();
	return 0;
}
