#include <iostream>
#include <stack>
#include <string>
using namespace std;

string s;

stack<char> st;

char rev[3] = { ')', '}', ']'};

bool process()
{
     int i;
     for (i = 0; i < s.size(); ++i) {
         if (s[i] == '(' || s[i] == '{' || s[i] == '[') st.push(s[i]);
         else switch(s[i]) {
              case ')': {
                   if (!st.empty() && st.top() == '(') st.pop(); 
                   else return false;
                   break;
              }
              case '}': {
                   if (!st.empty() && st.top() == '{') st.pop(); 
                   else return false;
                   break;
              }
              case ']': {
                   if (!st.empty() && st.top() == '[') st.pop(); 
                   else return false;
                   break;
              }
         }
     }
     if (!st.empty()) return false;
     return true;
} 
int main()
{
    int n;
    cin >> n;
    while (n) {
          cin >> s;
          if (process()) {
                         cout << "Guzel\n";
          }
          else cout << "Berbat\n";
          while(!st.empty()) st.pop();
          --n;
    }
    return 0;
}
