#include <iostream>
#include <string>
#include <cstring>

using namespace std;

int freq[8192];

void solve() {
	memset(freq, 0, sizeof(freq));
	int a, b;
	string s;
	cin>>a>>b>>s;
	int i = 0;
	int cmask = 0, bmask = (1<<a) - 1;
	for(; i < a; ++i) {
		cmask <<= 1;
		cmask |= s[i]-'0';
	}
	for(; i < s.size(); ++i) {
		++freq[cmask];
		cmask <<= 1;
		cmask |= s[i]-'0';
		cmask &= bmask;
	}
	++freq[cmask];
	int max = 0;
	for(int i = 0; i < 8192; ++i) {
		if(freq[i] > freq[max])
			max = i;
	}
	for(int i = 1<<(a-1); i; i >>= 1) {
		printf("%d", max&i ? 1 : 0);
	}
	printf("\n");
}

int main() {
	int n;
	cin>>n;
	for(int i = 0; i < n; ++i) solve();
	return 0;
}
